using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Reflection;
using System.ServiceModel;

using ObRun.ObMain;
using ObRun.ObServiceSupport;
using ObRun.ObUtils;

using BlobWCFService_DataContracts;

namespace BlobWCFServiceService
{
    public class BlobWCFServiceMarshaller
    {
		/// <summary>
        /// The Plex runtime instance.
        /// </summary>
        private ObApplicationService m_PlexApp = new ObApplicationService();

        /// <summary>
        /// The name of the runtime environment to use with the runtime instance.
        /// </summary>
        private String m_PlexEnvironment = "Default";

        /// <summary>
        /// A table of input parameters, stored in name/value pairs.
        /// </summary>
        private static Hashtable m_inputParms = new Hashtable();

        public BlobWCFServiceMarshaller()
        {
        }
        
        ~BlobWCFServiceMarshaller()
        {
			try
			{
				m_PlexApp.clearReferences();
				m_PlexApp = null;
			}
			catch (InvalidOperationException ex)
			{
			}
        }

        // This method calls the function 'AA3F' implemented by method 'BlockFetch'.
        public AA3F_Output BlockFetch(AA3F_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AA3F", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AA3F_Output output = new AA3F_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
        // This method calls the function 'AA4F' implemented by method 'CheckRow'.
        public AA4F_Output CheckRow(AA4F_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AA4F", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AA4F_Output output = new AA4F_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
        // This method calls the function 'AA8F' implemented by method 'DeleteRow'.
        public AA8F_Output DeleteRow(AA8F_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AA8F", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AA8F_Output output = new AA8F_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
        // This method calls the function 'AA9F' implemented by method 'InsertRow'.
        public AA9F_Output InsertRow(AA9F_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AA9F", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AA9F_Output output = new AA9F_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
        // This method calls the function 'AA5F' implemented by method 'SingleFetch'.
        public AA5F_Output SingleFetch(AA5F_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AA5F", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AA5F_Output output = new AA5F_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
        // This method calls the function 'AAaF' implemented by method 'UpdateRow'.
        public AAaF_Output UpdateRow(AAaF_Input input)
        {
            try
            {
				DataSet dsInput = m_PlexApp.getInputParmDataSet("TUTORIALWIN.AAaF", m_PlexEnvironment, "C#", "");
				input.ToDataSet(ref dsInput);
				DataSet dsOutput = new DataSet();
				dsOutput = m_PlexApp.M_ObCallMgr.obCallFunction(dsInput);
				AAaF_Output output = new AAaF_Output();
				output.FromDataSet(dsOutput);
				return output;
			}
			catch (ObRuntimeException e)
			{
				throw new FaultException<PlexRuntimeException>(new PlexRuntimeException(e), new FaultReason(e.Message));
			}
        }
        
    }  
}
